﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr187_3
{
    // Объявление делегата:
    delegate void MyDelegate(string txt);

    // Класс с событием: 
    class MyClass
    {
        private string name;
        // Конструктор
        public MyClass(string ni)
        {
            name = ni;
        }
        // Объявление события: 
        public event MyDelegate MyEvent;
        // Метод для генерирования события: 
        public void RaiseMyEvent()
        {
            // Если для события предусмотрены обработчики: 
            if (MyEvent != null)
            {
                // Генерирование события:
                MyEvent(name);
            }
        }
    }

    // Класс: 
    class Alpha
    {
        // Текстовое поле: 
        private string text;
        // Конструктор: 
        public Alpha(string txt)
        {
            text = txt;
        }
        // Метод отображает сообщение: 
        public void show(string obj)
        {
            Console.WriteLine("Объект, сгенерировавший событие: " + obj);
            Console.WriteLine("Сообщение: " + text);
        }
    }

    // Класс с главным методом:
    class Program
    {
        // Главный метод:
        static void Main()
        {
            // Два объекта первого класса:
            MyClass A = new MyClass("A");
            MyClass B = new MyClass("B");
            // Один объект второго класса:
            Alpha Obj = new Alpha("obj");
            // Добавление обработчика для события:
            A.MyEvent += Obj.show;
            B.MyEvent += Obj.show;
            // Генерация события:
            A.RaiseMyEvent();
            Console.WriteLine();
            // Генерация события:
            B.RaiseMyEvent();
            Console.WriteLine();
            // Задержка:
            Console.ReadLine();
        }
    }
}
